// This #include statement was automatically added by the Particle IDE.
#include <Adafruit_SSD1306.h>

// This #include statement was automatically added by the Particle IDE.
#include <Adafruit_TSL2561_U.h>

//OLED
#define OLED_DC     D4
#define OLED_CS     D5
#define OLED_RESET  D3
Adafruit_SSD1306 display(OLED_DC, OLED_RESET, OLED_CS);

#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2

#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 
static const unsigned char PROGMEM logo16_glcd_bmp[] =
{ };

#if (SSD1306_LCDHEIGHT != 64)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif

//light
Adafruit_TSL2561_Unified tsl = Adafruit_TSL2561_Unified(TSL2561_ADDR_FLOAT, 12345);

//soil moisture sensor
int sms = A0;
int analogvalue;

//light
double analogvalue1;

//motor
int motor = D2; 



void setup(void) 
{
  Serial.begin(9600);
  //oled
  display.begin(SSD1306_SWITCHCAPVCC);
  // init done
  
  // Show image buffer on the display hardware.
  // Since the buffer is intialized with an Adafruit splashscreen
  // internally, this will display the splashscreen.
  display.display();
  
  //soil
  pinMode(sms,INPUT);
  Particle.variable("analogvalue", &analogvalue, INT);
  
  //light
  Particle.variable("analogvalue1", &analogvalue1, DOUBLE);
  
  //motor
  pinMode(motor,OUTPUT);

}



void loop(void) 
{ 
  //light
  /* Get a new sensor event */ 
  sensors_event_t event;
  tsl.getEvent(&event);
  analogvalue1 = event.light;
  
  //soil
  analogvalue = analogRead(sms);
  //Serial.println(analogvalue);
  
  //motor
  if (analogvalue){
      if(analogvalue > 3000 ){
          digitalWrite(motor,HIGH);
          delay(2000);
          digitalWrite(motor,LOW);
      }else{
          digitalWrite(motor,LOW);
      }
  }
  
  //oled
  if(event.light < 30){
      Serial.println("zzz");
      display.clearDisplay();
      display.setTextSize(2);
      display.setTextColor(WHITE);
      display.setCursor(20,30);
      display.println("z.z...z");
      display.display();

  }else if(event.light> 2000){
      
      if(analogvalue<3000){
        Serial.println("laugh");
        display.clearDisplay();
        display.setTextSize(2);
        display.setTextColor(WHITE);
        display.setCursor(0,0);
        display.println(":D");
        display.println(" ");
        display.setTextSize(2);
        display.setTextColor(WHITE);
        display.setCursor(15,20);
        display.println("What a great day!");
        display.display();
      }
      
  }else if(analogvalue>3000){
      Serial.println("sad");
      display.clearDisplay();
      display.setTextSize(3);
      display.setTextColor(WHITE);
      display.setCursor(0,0);
      display.println(":(");
      display.println(" ");
      display.setTextSize(2);
      display.setTextColor(WHITE);
      display.setCursor(15,20);
      display.println("I feel sad.");
      display.display();

  }else{
      Serial.println("smile");
      display.clearDisplay();
      display.setTextSize(3);
      display.setTextColor(WHITE);
      display.setCursor(20,30);
      display.println(":)");
      display.display();
  }
  
  //delay(5000);
  delay(36000000);
}

